<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'StartSignature' => 'StartSignature',
            'StartSignatureResponse' => 'StartSignatureResponse',
            'StartSignatureTemplate' => 'StartSignatureTemplate',
            'StartSignatureTemplateResponse' => 'StartSignatureTemplateResponse',
            'StartSignatureTemplateEx' => 'StartSignatureTemplateEx',
            'StartSignatureTemplateExResponse' => 'StartSignatureTemplateExResponse',
            'EndSignature' => 'EndSignature',
            'EndSignatureResponse' => 'EndSignatureResponse',
            'StartBatchSignature' => 'StartBatchSignature',
            'StartBatchSignatureResponse' => 'StartBatchSignatureResponse',
            'EndBatchSignature' => 'EndBatchSignature',
            'EndBatchSignatureResponse' => 'EndBatchSignatureResponse',
            'AddDocument' => 'AddDocument',
            'AddDocumentResponse' => 'AddDocumentResponse',
            'AddDocumentTemplate' => 'AddDocumentTemplate',
            'AddDocumentTemplateResponse' => 'AddDocumentTemplateResponse',
            'AddDocumentTemplateEx' => 'AddDocumentTemplateEx',
            'AddDocumentTemplateExResponse' => 'AddDocumentTemplateExResponse',
            'GetDocument' => 'GetDocument',
            'GetDocumentResponse' => 'GetDocumentResponse',
            'GetCertificate' => 'GetCertificate',
            'GetCertificateResponse' => 'GetCertificateResponse',
            'UploadTemplate' => 'UploadTemplate',
            'UploadTemplateResponse' => 'UploadTemplateResponse',
            'ReplaceTemplate' => 'ReplaceTemplate',
            'ReplaceTemplateResponse' => 'ReplaceTemplateResponse',
            'GetTemplate' => 'GetTemplate',
            'GetTemplateResponse' => 'GetTemplateResponse',
            'DeleteTemplate' => 'DeleteTemplate',
            'DeleteTemplateResponse' => 'DeleteTemplateResponse',
            'ListTemplate' => 'ListTemplate',
            'ListTemplateResponse' => 'ListTemplateResponse',
            'DoP12Signature' => 'DoP12Signature',
            'DoP12SignatureResponse' => 'DoP12SignatureResponse',
            'DoP12SignatureTemplate' => 'DoP12SignatureTemplate',
            'DoP12SignatureTemplateResponse' => 'DoP12SignatureTemplateResponse',
            'DoP12SignatureTemplateEx' => 'DoP12SignatureTemplateEx',
            'DoP12SignatureTemplateExResponse' => 'DoP12SignatureTemplateExResponse',
            'getWBPK' => 'GetWBPK',
            'getWBPKResponse' => 'GetWBPKResponse',
        );
    }
}
