<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UploadTemplate StructType
 * @subpackage Structs
 */
class UploadTemplate extends AbstractStructBase
{
    /**
     * The APIKey
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $APIKey;
    /**
     * The TemplateData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TemplateData;
    /**
     * Constructor method for UploadTemplate
     * @uses UploadTemplate::setAPIKey()
     * @uses UploadTemplate::setTemplateData()
     * @param string $aPIKey
     * @param string $templateData
     */
    public function __construct($aPIKey = null, $templateData = null)
    {
        $this
            ->setAPIKey($aPIKey)
            ->setTemplateData($templateData);
    }
    /**
     * Get APIKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAPIKey()
    {
        return isset($this->APIKey) ? $this->APIKey : null;
    }
    /**
     * Set APIKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $aPIKey
     * @return UploadTemplate
     */
    public function setAPIKey($aPIKey = null)
    {
        // validation for constraint: string
        if (!is_null($aPIKey) && !is_string($aPIKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aPIKey, true), gettype($aPIKey)), __LINE__);
        }
        if (is_null($aPIKey) || (is_array($aPIKey) && empty($aPIKey))) {
            unset($this->APIKey);
        } else {
            $this->APIKey = $aPIKey;
        }
        return $this;
    }
    /**
     * Get TemplateData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTemplateData()
    {
        return isset($this->TemplateData) ? $this->TemplateData : null;
    }
    /**
     * Set TemplateData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $templateData
     * @return UploadTemplate
     */
    public function setTemplateData($templateData = null)
    {
        // validation for constraint: string
        if (!is_null($templateData) && !is_string($templateData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($templateData, true), gettype($templateData)), __LINE__);
        }
        if (is_null($templateData) || (is_array($templateData) && empty($templateData))) {
            unset($this->TemplateData);
        } else {
            $this->TemplateData = $templateData;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return UploadTemplate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
